diff --git a/docs/reference/intel-gpu-tools/Makefile.am b/docs/reference/intel-gpu-tools/Makefile.am
index 8364247..0363014 100644
--- a/docs/reference/intel-gpu-tools/Makefile.am
+++ b/docs/reference/intel-gpu-tools/Makefile.am
@@ -126,7 +126,8 @@ EXTRA_HFILES=
 # e.g. IGNORE_HFILES=gtkdebug.h gtkintl.h private_code
 IGNORE_HFILES=gen6_render.h gen7_media.h gen7_render.h gen8_media.h \
 	      gen8_render.h i830_reg.h i915_3d.h i915_pciids.h i915_reg.h \
-	      intel_reg.h debug.h instdone.h media_fill.h rendercopy.h
+	      intel_reg.h debug.h instdone.h media_fill.h rendercopy.h \
+	      media_spin.h media_fill_gen9.h gen9_render.h version.h
 
 # Images to copy into HTML directory.
 # e.g. HTML_IMAGES=$(top_srcdir)/gtk/stock-icons/stock_about_24.png
diff --git a/docs/reference/intel-gpu-tools/intel-gpu-tools-docs.xml b/docs/reference/intel-gpu-tools/intel-gpu-tools-docs.xml
index 6c953fd..a6d1f89 100644
--- a/docs/reference/intel-gpu-tools/intel-gpu-tools-docs.xml
+++ b/docs/reference/intel-gpu-tools/intel-gpu-tools-docs.xml
@@ -18,6 +18,7 @@
     <xi:include href="xml/drmtest.xml"/>
     <xi:include href="xml/igt_core.xml"/>
     <xi:include href="xml/igt_debugfs.xml"/>
+    <xi:include href="xml/igt_draw.xml"/>
     <xi:include href="xml/igt_kms.xml"/>
     <xi:include href="xml/igt_fb.xml"/>
     <xi:include href="xml/igt_aux.xml"/>
diff --git a/lib/igt_draw.c b/lib/igt_draw.c
index 14e470f..51dce4b 100644
--- a/lib/igt_draw.c
+++ b/lib/igt_draw.c
@@ -68,6 +68,7 @@ struct rect {
 
 /**
  * igt_draw_get_method_name:
+ * @method: draw method
  *
  * Simple function to transform the enum into a string. Useful when naming
  * subtests and printing debug messages.
@@ -533,6 +534,17 @@ void igt_draw_rect(int fd, drm_intel_bufmgr *bufmgr, drm_intel_context *context,
 
 /**
  * igt_draw_rect_fb:
+ * @fd: the DRM file descriptor
+ * @bufmgr: the libdrm bufmgr, only required for IGT_DRAW_BLT and
+ *          IGT_DRAW_RENDER
+ * @context: the context, can be NULL if you don't want to think about it
+ * @fb: framebuffer
+ * @method: method you're going to use to write to the buffer
+ * @rect_x: horizontal position on the buffer where your rectangle starts
+ * @rect_y: vertical position on the buffer where your rectangle starts
+ * @rect_w: width of the rectangle
+ * @rect_h: height of the rectangle
+ * @color: color of the rectangle
  *
  * This is exactly the same as igt_draw_rect, but you can pass an igt_fb instead
  * of manually providing its details. See igt_draw_rect.
diff --git a/lib/igt_draw.h b/lib/igt_draw.h
index 61ffad5..9d8413a 100644
--- a/lib/igt_draw.h
+++ b/lib/igt_draw.h
@@ -29,10 +29,10 @@
 #include "igt_fb.h"
 
 /**
- *igt_draw_method:
+ * igt_draw_method:
  * @IGT_DRAW_MMAP_CPU: draw using a CPU mmap.
  * @IGT_DRAW_MMAP_GTT: draw using a GTT mmap.
- * @IGT-DRAW_MMAP_WC: draw using the WC mmap.
+ * @IGT_DRAW_MMAP_WC: draw using the WC mmap.
  * @IGT_DRAW_PWRITE: draw using the pwrite ioctl.
  * @IGT_DRAW_BLT: draw using the BLT ring.
  * @IGT_DRAW_RENDER: draw using the render ring.
diff --git a/lib/igt_kms.c b/lib/igt_kms.c
index 0665d70..f5670e0 100644
--- a/lib/igt_kms.c
+++ b/lib/igt_kms.c
@@ -1824,11 +1824,12 @@ void igt_plane_set_size(igt_plane_t *plane, int w, int h)
 /**
  * igt_fb_set_position:
  * @fb: framebuffer pointer
+ * @plane: plane
  * @x: X position
  * @y: Y position
  *
  * This function sets position for requested framebuffer as src to plane.
- * New position will be commited at plane commit time via drmModeSetPlane().
+ * New position will be committed at plane commit time via drmModeSetPlane().
  */
 void igt_fb_set_position(struct igt_fb *fb, igt_plane_t *plane,
 	uint32_t x, uint32_t y)
@@ -1846,13 +1847,14 @@ void igt_fb_set_position(struct igt_fb *fb, igt_plane_t *plane,
 }
 
 /**
- * igt_fb_set_position:
+ * igt_fb_set_size:
  * @fb: framebuffer pointer
+ * @plane: plane
  * @w: width
  * @h: height
  *
  * This function sets fetch rect size from requested framebuffer as src
- * to plane. New size will be commited at plane commit time via
+ * to plane. New size will be committed at plane commit time via
  * drmModeSetPlane().
  */
 void igt_fb_set_size(struct igt_fb *fb, igt_plane_t *plane,